' -------------------------------------------------------
' Baseplate with Hole Underside (bp_hu.lds)
' Author : J.C. Tchang
' Script for LDS
' Version 1.1 05-12-2009
' -------------------------------------------------------
' Parameters
' Studs Number in Z (modify value)
LET H=16
' Studs Number in X (modify value)
LET W=24
' -------------------------------------------------------
' Main Program
'
PRINT "0 Baseplate" H "x" W
PRINT "0 Name: bp_hq.dat"
PRINT "0 Author: LDS by J.C. Tchang's Script bp_hu.lds"
PRINT "0 !LDRAW_ORG Unofficial_Part"
PRINT "0 !LICENSE Redistributable under CCAL version 2.0 : see CAreadme.txt"
PRINT ""
PRINT "0 BFC CERTIFY CCW"
PRINT ""
PRINT "0 // Holes"
'
' Init values
LET I=1
LET J=1
LET X1=(W/2)*20
LET X1=X1-10
LET Z1=(H/2)*20
LET Z1=Z1-10
'
' Insert Underside stud
'
' Standard Range ?
:Range
IF J<H THEN GOTO :Range1
'
' Last Range
IF I=W THEN
  1 16 X1 0 Z1 -1 0 0 0 1 0 0 0 -1 studbp1.dat
ELSE
  1 16 X1 0 Z1 0 0 1 0 1 0 -1 0 0 studbp2.dat
ENDIF
GOTO :Range2
,
' Standard Range
:Range1
IF I=W THEN
  1 16 X1 0 Z1 1 0 0 0 1 0 0 0 1 studbp2.dat
ELSE
  1 16 X1 0 Z1 0 0 1 0 1 0 -1 0 0 studbp3.dat
ENDIF
'
' Next Column
:Range2
LET I=I+1
LET X1=X1-20
IF I>W THEN GOTO :Suite1
GOTO :Range
'
' Next Range
:Suite1
LET I=1
LET J=J+1
IF J>H THEN GOTO :Suite2
LET X1=(W/2)*20
LET X1=X1-10
LET Z1=Z1-20
PRINT "0 //"
GOTO :Range
'
' Insert Corner
:Suite2
PRINT ""
PRINT "0 // Corner"
'
MIRROR X
MIRROR Z
GOSUB :Corner
MIRROR OFF
'
' Insert Horizontal Edge
PRINT ""
PRINT "0 // Horizontal Edge"
MIRROR Z
GOSUB :Hedge
MIRROR OFF
'
' Insert Vertical Edge
PRINT ""
PRINT "0 // Vertical Edge"
MIRROR X
GOSUB :Vedge
MIRROR OFF
'
' Insert Stud (Sorry, Not Optimized, Orientation is Not Valided)
'
PRINT "0 // Stud"
LET S=0
'
IF H>8 THEN GOTO :Stud2
IF W=8 THEN
 1 16 0 0 0 1 0 0 0 1 0 0 0 1 stug8.dat
ENDIF
IF W=12 THEN
 LET S=1
 1 16 40 0 0 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -80 0 40 1 0 0 0 1 0 0 0 1 stug4.dat
 1 16 -80 0 -40 1 0 0 0 1 0 0 0 1 stug4.dat
ENDIF
IF W=16 THEN
 LET S=1
 1 16 80 0 0 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -80 0 0 1 0 0 0 1 0 0 0 1 stug8.dat
ENDIF
IF W=24 THEN
 LET S=1
 1 16 0 0 0 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 160 0 0 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -160 0 0 1 0 0 0 1 0 0 0 1 stug8.dat
ENDIF
IF W=32 THEN
 LET S=1
 1 16 80 0 0 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -80 0 0 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 240 0 0 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -240 0 0 1 0 0 0 1 0 0 0 1 stug8.dat
ENDIF
GOTO :Studf
'
:Stud2
IF H>16 THEN GOTO :Stud3
IF W=16 THEN
 LET S=1
 1 16 80 0 80 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -80 0 80 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 80 0 -80 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -80 0 -80 1 0 0 0 1 0 0 0 1 stug8.dat
ENDIF
IF W=18 THEN
 LET S=1
 1 16 60 0 80 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -100 0 80 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 60 0 -80 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -100 0 -80 1 0 0 0 1 0 0 0 1 stug8.dat

 1 16 160 0 140 1 0 0 0 1 0 0 0 1 stug2.dat
 1 16 160 0 100 1 0 0 0 1 0 0 0 1 stug2.dat
 1 16 160 0 60 1 0 0 0 1 0 0 0 1 stug2.dat
 1 16 160 0 20 1 0 0 0 1 0 0 0 1 stug2.dat
 1 16 160 0 -20 1 0 0 0 1 0 0 0 1 stug2.dat
 1 16 160 0 -60 1 0 0 0 1 0 0 0 1 stug2.dat
 1 16 160 0 -100 1 0 0 0 1 0 0 0 1 stug2.dat
 1 16 160 0 -140 1 0 0 0 1 0 0 0 1 stug2.dat
ENDIF
IF W=22 THEN
 LET S=1
 1 16 20 0 80 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -140 0 80 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 20 0 -80 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -140 0 -80 1 0 0 0 1 0 0 0 1 stug8.dat

 1 16 160 0 100 1 0 0 0 1 0 0 0 1 stug6.dat
 1 16 160 0 -20 1 0 0 0 1 0 0 0 1 stug6.dat
 1 16 140 0 -120 1 0 0 0 1 0 0 0 1 stug4.dat
 1 16 200 0 -100 1 0 0 0 1 0 0 0 1 stug2.dat
 1 16 200 0 -140 1 0 0 0 1 0 0 0 1 stug2.dat
ENDIF
IF W=24 THEN
 LET S=1
 ' Orientation stud OK
 1 16 0 0 80 0 0 1 0 1 0 -1 0 0 stug8.dat
 1 16 160 0 80 0 0 1 0 1 0 -1 0 0 stug8.dat
 1 16 -160 0 80 0 0 1 0 1 0 -1 0 0 stug8.dat
 1 16 0 0 -80 0 0 1 0 1 0 -1 0 0 stug8.dat
 1 16 160 0 -80 0 0 1 0 1 0 -1 0 0 stug8.dat
 1 16 -160 0 -80 0 0 1 0 1 0 -1 0 0 stug8.dat
ENDIF
IF W=32 THEN
 LET S=1
 ' Orientation stud OK
 1 16 80 0 80 0 0 1 0 1 0 -1 0 0 stug8.dat
 1 16 -80 0 80 0 0 1 0 1 0 -1 0 0 stug8.dat
 1 16 240 0 80 0 0 1 0 1 0 -1 0 0 stug8.dat
 1 16 -240 0 80 0 0 1 0 1 0 -1 0 0 stug8.dat
 1 16 80 0 -80 0 0 1 0 1 0 -1 0 0 stug8.dat
 1 16 -80 0 -80 0 0 1 0 1 0 -1 0 0 stug8.dat
 1 16 240 0 -80 0 0 1 0 1 0 -1 0 0 stug8.dat
 1 16 -240 0 -80 0 0 1 0 1 0 -1 0 0 stug8.dat
ENDIF
GOTO :Studf
'
:Stud3
IF H>24 THEN GOTO :Stud4
IF W=32 THEN
 LET S=1
 1 16 80 0 0 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -80 0 0 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 240 0 0 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -240 0 0 1 0 0 0 1 0 0 0 1 stug8.dat

 1 16 80 0 160 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -80 0 160 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 240 0 160 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -240 0 160 1 0 0 0 1 0 0 0 1 stug8.dat

 1 16 80 0 -160 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -80 0 -160 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 240 0 -160 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -240 0 -160 1 0 0 0 1 0 0 0 1 stug8.dat
ENDIF
IF W=40 THEN
 LET S=1
 1 16 0 0 0 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 160 0 0 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -160 0 0 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 320 0 0 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -320 0 0 1 0 0 0 1 0 0 0 1 stug8.dat

 1 16 0 0 160 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 160 0 160 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -160 0 160 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 320 0 160 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -320 0 160 1 0 0 0 1 0 0 0 1 stug8.dat

 1 16 0 0 -160 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 160 0 -160 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -160 0 -160 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 320 0 -160 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -320 0 -160 1 0 0 0 1 0 0 0 1 stug8.dat
ENDIF
GOTO :Studf
'
:Stud4
IF H>32 THEN GOTO :Stud5
IF W=32 THEN
 LET S=1
 1 16 80 0 80 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -80 0 80 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 240 0 80 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -240 0 80 1 0 0 0 1 0 0 0 1 stug8.dat

 1 16 80 0 240 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -80 0 240 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 240 0 240 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -240 0 240 1 0 0 0 1 0 0 0 1 stug8.dat

 1 16 80 0 -80 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -80 0 -80 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 240 0 -80 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -240 0 -80 1 0 0 0 1 0 0 0 1 stug8.dat

 1 16 80 0 -240 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -80 0 -240 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 240 0 -240 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -240 0 -240 1 0 0 0 1 0 0 0 1 stug8.dat
ENDIF
GOTO :Studf
'
:Stud5
IF H>48 THEN GOTO :Stud6
IF W=48 THEN
 LET S=1
 1 16 80 0 80 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -80 0 80 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 240 0 80 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -240 0 80 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 400 0 80 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -400 0 80 1 0 0 0 1 0 0 0 1 stug8.dat

 1 16 80 0 240 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -80 0 240 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 240 0 240 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -240 0 240 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 400 0 240 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -400 0 240 1 0 0 0 1 0 0 0 1 stug8.dat

 1 16 80 0 400 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -80 0 400 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 240 0 400 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -240 0 400 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 400 0 400 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -400 0 400 1 0 0 0 1 0 0 0 1 stug8.dat

 1 16 80 0 -80 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -80 0 -80 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 240 0 -80 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -240 0 -80 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 400 0 -80 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -400 0 -80 1 0 0 0 1 0 0 0 1 stug8.dat

 1 16 80 0 -240 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -80 0 -240 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 240 0 -240 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -240 0 -240 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 400 0 -240 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -400 0 -240 1 0 0 0 1 0 0 0 1 stug8.dat

 1 16 80 0 -400 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -80 0 -400 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 240 0 -400 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -240 0 -400 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 400 0 -400 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -400 0 -400 1 0 0 0 1 0 0 0 1 stug8.dat
ENDIF
GOTO :Studf
'
:Stud6
IF H>50 THEN GOTO :Studf
IF W=50 THEN
 LET S=1
 1 16 -420 0 420 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -260 0 420 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -100 0 420 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 60 0 420 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 220 0 420 1 0 0 0 1 0 0 0 1 stug8.dat

 1 16 -420 0 260 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -260 0 260 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -100 0 260 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 60 0 260 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 220 0 260 1 0 0 0 1 0 0 0 1 stug8.dat

 1 16 -420 0 100 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -260 0 100 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -100 0 100 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 60 0 100 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 220 0 100 1 0 0 0 1 0 0 0 1 stug8.dat

 1 16 -420 0 -60 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -260 0 -60 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -100 0 -60 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 60 0 -60 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 220 0 -60 1 0 0 0 1 0 0 0 1 stug8.dat

 1 16 -420 0 -220 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -260 0 -220 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 -100 0 -220 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 60 0 -220 1 0 0 0 1 0 0 0 1 stug8.dat
 1 16 220 0 -220 1 0 0 0 1 0 0 0 1 stug8.dat

 1 16 350 0 450 1 0 0 0 1 0 0 0 1 stug5.dat
 1 16 450 0 450 1 0 0 0 1 0 0 0 1 stug5.dat
 1 16 350 0 350 1 0 0 0 1 0 0 0 1 stug5.dat
 1 16 450 0 350 1 0 0 0 1 0 0 0 1 stug5.dat
 1 16 350 0 250 1 0 0 0 1 0 0 0 1 stug5.dat
 1 16 450 0 250 1 0 0 0 1 0 0 0 1 stug5.dat
 1 16 350 0 150 1 0 0 0 1 0 0 0 1 stug5.dat
 1 16 450 0 150 1 0 0 0 1 0 0 0 1 stug5.dat
 1 16 350 0 50 1 0 0 0 1 0 0 0 1 stug5.dat
 1 16 450 0 50 1 0 0 0 1 0 0 0 1 stug5.dat
 1 16 350 0 -50 1 0 0 0 1 0 0 0 1 stug5.dat
 1 16 450 0 -50 1 0 0 0 1 0 0 0 1 stug5.dat
 1 16 350 0 -150 1 0 0 0 1 0 0 0 1 stug5.dat
 1 16 450 0 -150 1 0 0 0 1 0 0 0 1 stug5.dat
 1 16 350 0 -250 1 0 0 0 1 0 0 0 1 stug5.dat
 1 16 450 0 -250 1 0 0 0 1 0 0 0 1 stug5.dat

 1 16 -450 0 -350 1 0 0 0 1 0 0 0 1 stug5.dat
 1 16 -450 0 -450 1 0 0 0 1 0 0 0 1 stug5.dat
 1 16 -350 0 -350 1 0 0 0 1 0 0 0 1 stug5.dat
 1 16 -350 0 -450 1 0 0 0 1 0 0 0 1 stug5.dat
 1 16 -250 0 -350 1 0 0 0 1 0 0 0 1 stug5.dat
 1 16 -250 0 -450 1 0 0 0 1 0 0 0 1 stug5.dat
 1 16 -150 0 -350 1 0 0 0 1 0 0 0 1 stug5.dat
 1 16 -150 0 -450 1 0 0 0 1 0 0 0 1 stug5.dat
 1 16 -50 0 -350 1 0 0 0 1 0 0 0 1 stug5.dat
 1 16 -50 0 -450 1 0 0 0 1 0 0 0 1 stug5.dat
 1 16 50 0 -350 1 0 0 0 1 0 0 0 1 stug5.dat
 1 16 50 0 -450 1 0 0 0 1 0 0 0 1 stug5.dat
 1 16 150 0 -350 1 0 0 0 1 0 0 0 1 stug5.dat
 1 16 150 0 -450 1 0 0 0 1 0 0 0 1 stug5.dat
 1 16 250 0 -350 1 0 0 0 1 0 0 0 1 stug5.dat
 1 16 250 0 -450 1 0 0 0 1 0 0 0 1 stug5.dat
 1 16 350 0 -350 1 0 0 0 1 0 0 0 1 stug5.dat
 1 16 350 0 -450 1 0 0 0 1 0 0 0 1 stug5.dat
 1 16 450 0 -350 1 0 0 0 1 0 0 0 1 stug5.dat
 1 16 450 0 -450 1 0 0 0 1 0 0 0 1 stug5.dat
ENDIF
'
:Studf
IF S=0 THEN
 1 16 0 0 0 1 0 0 0 1 0 0 0 1 stug8.dat
ENDIF
'
' -------------------------------------------------------
' End of Script
'
:End
PRINT "0 // End Script bp_hu.lds"
END
' =======================================================
' -------------------------------------------------------
' Sub-Program Compute Corner
'
:Corner
LET X2=(W/2)*20
LET X2=X2-9.249
LET Z2=(H/2)*20
LET Z2=Z2-9.239
1 16 X2 0 Z2 9.2388 0 -3.82683 0 1 0 3.82683 0 9.2388 1-8edge.dat
1 16 X2 4 Z2 9.2388 0 -3.82683 0 1 0 3.82683 0 9.2388 1-8edge.dat
1 16 X2 0 Z2 9.2388 0 -3.82683 0 4 0 3.82683 0 9.2388 1-8cyli.dat
'
LET X3=(W/2)*20
LET X3=X3-4
LET Z3=(H/2)*20
LET Z3=Z3-4
4 16 X3 0 Z3 X3+4 0 Z3-1.412 X3+1.822 0 Z3+1.832 X3-1.422 0 Z3+4
4 16 X3 4 Z3 X3-1.422 4 Z3+4 X3+1.822 4 Z3+1.832 X3+4 4 Z3-1.412  
'
RETURN
' -------------------------------------------------------
' Sub-Program Compute Horizontal Edges
'
:Hedge
LET X3=(W/2)*20
LET X3=X3-4
LET Z3=(H/2)*20
LET Z3=Z3-4
4 16 X3 0 Z3 X3-1.422 0 Z3+4 (X3-1.422)*-1 0 Z3+4 X3*-1 0 Z3
4 16 X3 4 Z3 X3*-1 4 Z3 (X3-1.422)*-1 4 Z3+4 X3-1.422 4 Z3+4
1 16 0 2 Z3+4 X3-1.422 0 0 0 0 -2 0 -1 0 rect.dat
'
RETURN
' -------------------------------------------------------
' Sub-Program Compute Vertical Edges
'
:Vedge
LET X3=(W/2)*20
LET X3=X3-4
LET Z3=(H/2)*20
LET Z3=Z3-4
4 16 X3 0 Z3 X3 0 Z3*-1 X3+4 0 (Z3-1.412)*-1 X3+4 0 Z3-1.412
4 16 X3 4 Z3 X3+4 4 Z3-1.412 X3+4 4 (Z3-1.412)*-1 X3 4 Z3*-1
1 16 X3+4 2 0 0 -1 0 0 0 2 Z3-1.412 0 0 rect.dat
'
RETURN
' -------------------------------------------------------
