' -------------------------------------------------------
' Plate with Hight Defintion (plate_hd.lds)
' Author : J.C. Tchang
' Script for LDS
' Version 1.0 24-06-2010 : Not Optimized for T junction
' -------------------------------------------------------
' Parameters
' Studs Number in Z (modify value)
LET H=8
' Studs Number in X (modify value)
LET W=11
'
' -------------------------------------------------------
' Main Program
'
PRINT "0 Plate" H "x" W "Hight Definition"
PRINT "0 Name: plate_hd.dat"
PRINT "0 Author: LDS by J.C. Tchang's Script plate_hd.lds"
PRINT "0 !LDRAW_ORG Unofficial_Part"
PRINT "0 !LICENSE Redistributable under CCAL version 2.0 : see CAreadme.txt"
PRINT ""
PRINT "0 BFC CERTIFY CCW"
PRINT ""
'
' -------------------------------------------------------
' Insert Under stud
'
PRINT "0 // Under Stud"
'
' Init values
LET I=1
LET J=1
LET X1=(W/2)*20
LET X1=X1-20
LET Z1=(H/2)*20
LET Z1=Z1-20
'
' Standard Range for 1xN or 2xN to NxN
:Range3
IF W=1 THEN GOTO :Suite4
IF H=1 THEN
  1 16 X1 3 Z1+10 1 0 0 0 -1 0 0 0 1 stu33.dat
ELSE
  1 16 X1 3 Z1 1 0 0 0 -1 0 0 0 1 stu34.dat
ENDIF
'
' Next Column
:Range2
LET I=I+1
LET X1=X1-20
IF I>(W-1) THEN GOTO :Suite3
GOTO :Range3
'
' Next Range
:Suite3
LET I=1
LET J=J+1
IF J>(H-1) THEN GOTO :Suite4
LET X1=(W/2)*20
LET X1=X1-20
LET Z1=Z1-20
PRINT "0 //"
GOTO :Range3
'
:Suite4
'
' -------------------------------------------------------
' Insert Under Box for Plate 2xN to NxN
'
PRINT "0 // Under Box"
'
IF H=1 THEN GOTO :Suite6
'
' Init values
LET I=1
LET J=1
LET X1=(W/2)*20
LET X1=X1-6.5
LET Z1=(H/2)*20
LET Z1=Z1-13.5
'
' Standard Range
:Range5
4 16 X1 3 Z1 X1 3 Z1-13 X1-7 3 Z1-13 X1-7 3 Z1
'
' Next Column
:Range6
LET I=I+1
LET X1=X1-20
IF I>W THEN GOTO :Suite5
GOTO :Range5
'
' Next Range
:Suite5
LET I=1
LET J=J+1
IF J>(H-1) THEN GOTO :Suite6
LET X1=(W/2)*20
LET X1=X1-6.5
LET Z1=Z1-20
PRINT "0 //"
GOTO :Range5
'
:Suite6
'
' -------------------------------------------------------
' Insert Under Box 2
'
IF W=1 THEN GOTO :Suite8
'
' Init values
LET I=1
LET X1=(W/2)*20
LET X1=X1-13.5
LET Z1=(H/2)*20
LET Z1=Z1-6.5
'
' Standard Range
:Range7
4 16 X1 3 Z1 X1 3 Z1*(-1) X1-13 3 Z1*(-1) X1-13 3 Z1
'
' Next Column
:Range8
LET I=I+1
LET X1=X1-20
IF I>(W-1) THEN GOTO :Suite8
GOTO :Range7
'
:Suite8
'
' -------------------------------------------------------
' Insert Under Box 3
'
' Init values
LET X1=(W/2)*20
LET X1=X1-4
LET Z1=(H/2)*20
LET Z1=Z1-4
'
MIRROR Z
4 16 X1 3 Z1 X1-2.5 3 Z1-2.5 (X1-2.5)*(-1) 3 Z1-2.5 X1*(-1) 3 Z1
MIRROR OFF
'
MIRROR X
4 16 X1 3 Z1 X1 3 Z1*(-1) X1-2.5 3 (Z1-2.5)*(-1) X1-2.5 3 Z1-2.5
MIRROR OFF
'
PRINT "0 BFC INVERTNEXT"
1 16 0 8 0 X1 0 0 0 -5 0 0 0 Z1 box4.dat
PRINT "0 //"
'
LET X1=(W/2)*20
LET Z1=(H/2)*20
'
MIRROR Z
4 16 X1 8 Z1 X1-4 8 Z1-4 (X1-4)*(-1) 8 Z1-4 X1*(-1) 8 Z1
MIRROR OFF
'
MIRROR X
4 16 X1 8 Z1 X1 8 Z1*(-1) X1-4 8 (Z1-4)*(-1) X1-4 8 Z1-4
MIRROR OFF
'
' -------------------------------------------------------
' Insert External Box
'
' Init values
LET X1=(W/2)*20
LET Z1=(H/2)*20
'
PRINT "0 // External Box"
1 16 0 8 0 X1 0 0 0 -8 0 0 0 Z1 box4.dat
PRINT "0 //"
'
' -------------------------------------------------------
' Insert Top Box for Plate 2xN to NxN
'
IF H=1 THEN GOTO :Suite16
'
' Init values
LET I=1
LET J=1
LET X1=(W/2)*20
LET X1=X1-4
LET Z1=(H/2)*20
LET Z1=Z1-16
'
' Standard Range
:Range15
4 16 X1 0 Z1 X1-12 0 Z1 X1-12 0 Z1-8 X1 0 Z1-8
'
' Next Column
:Range16
LET I=I+1
LET X1=X1-20
IF I>W THEN GOTO :Suite15
GOTO :Range15
'
' Next Range
:Suite15
LET I=1
LET J=J+1
IF J>(H-1) THEN GOTO :Suite16
LET X1=(W/2)*20
LET X1=X1-4
LET Z1=Z1-20
PRINT "0 //"
GOTO :Range15
'
:Suite16
'
' -------------------------------------------------------
' Insert Top Box 2
'
' Init values
LET X1=(W/2)*20
LET Z1=(H/2)*20
'
MIRROR Z
4 16 X1 0 Z1 X1*(-1) 0 Z1 (X1-4)*(-1) 0 Z1-4 X1-4 0 Z1-4
MIRROR OFF
'
MIRROR X
4 16 X1 0 Z1 X1-4 0 Z1-4 X1-4 0 (Z1-4)*(-1) X1 0 Z1*(-1)
MIRROR OFF
'
' -------------------------------------------------------
' Insert Top Box 3
'
IF W=1 THEN GOTO :Suite18
'
' Init values
LET I=1
LET X1=(W/2)*20
LET X1=X1-16
LET Z1=(H/2)*20
LET Z1=Z1-4
'
' Standard Range
:Range17
4 16 X1 0 Z1 X1-8 0 Z1 X1-8 0 Z1*(-1) X1 0 Z1*(-1)
'
' Next Column
:Range18
LET I=I+1
LET X1=X1-20
IF I>(W-1) THEN GOTO :Suite18
GOTO :Range17
'
:Suite18
'
' -------------------------------------------------------
' Insert Top Stud
'
PRINT "0 // Stud"
'
' Init values
LET I=1
LET J=1
LET X1=(W/2)*20
LET X1=X1-10
LET Z1=(H/2)*20
LET Z1=Z1-10
'
' Standard Range
:Range20
1 16 X1 0 Z1 1 0 0 0 1 0 0 0 1 stu3a.dat
'
' Next Column
:Range21
LET I=I+1
LET X1=X1-20
IF I>W THEN GOTO :Suite21
GOTO :Range20
'
' Next Range
:Suite21
LET I=1
LET J=J+1
IF J>H THEN GOTO :Suite22
LET X1=(W/2)*20
LET X1=X1-10
LET Z1=Z1-20
GOTO :Range20
'
:Suite22
'
' -------------------------------------------------------
' End of Script
'
:End
PRINT "0 //"
END
' =======================================================
