' -------------------------------------------------------
' Sticker band
' Author : J.C. Tchang
' Script for LDS
' Modif A 13-05-2010 : Add box5-12 usage
' -------------------------------------------------------
' Parameters
' Height of Sticker in LDU (modify value)
LET H=60
' Width of Sticker in LDU (modify value)
LET W=188
' Thickness of Sticker in LDU (default value)
LET T=0.25
' Color of Sticker (modify value)
LET C=WHITE
' 0=box 5 faces or 1=box5-12.dat
LET F=1
' Color of Band 1 (modify value)
LET D=blue
' Color of Band 2 (modify value)
LET E=15
' Width in x of Band 1 in LDU (modify value)
LET X1=46.6
' Width in x of Band 2 in LDU (modify value)
LET X2=46.6
' Length in x of Band 1 in LDU (modify value)
' Note: for this program version X3 > X1 and X3 > X2
' Note: for this program version X3 < W
LET X3=60
' Origin Delta in x of Band 1 in LDU (modify value)
' Note: for this program version X4 < X1
LET X4=2
' -------------------------------------------------------
' Main Program
PRINT "0 Sticker band";
PRINT W;
PRINT "x";
PRINT H
PRINT "0 Name: stk_band.dat"
PRINT "0 Author: LDS by J.C. Tchang's Script stk_band.lds"
PRINT "0 BFC CERTIFY CW"
PRINT "0 //"
PRINT "0 // Bands"
'
' Init values
LET H=H/2
LET W=W/2
LET F = D
'
' Top Box Values
P91 W*-1 T*-1 H*-1
P92 W*-1 T*-1 H
P93 W T*-1 H
P94 W T*-1 H*-1
'
' Init Points of Bands (Pos -1)
P11 (W*-1)+X4 T*-1 H*-1
LET X11=X11-X1
P12 X11+X3 T*-1 H
P13 X12+X1 T*-1 H
P14 X11+X1 T*-1 H*-1
P31 X11+X1 Y11 Z11
P32 X12+X1 Y12 Z12
P33 (X12+X2)+X1 Y12 Z12
P34 (X11+X2)+X1 Y11 Z11
'
' Init Band values (Compute)
GOSUB :Band
' -------------------------------------------------------
' Compute : Complete Band
'
:Start
'PRINT "0 Complete X11 =" X11 "X12 =" X12 "X13 =" X13 "X14 =" X14
'
IF X11>X94 THEN GOTO :StartPre
IF X13>X94 THEN GOTO :Suite1
'
4 F P11 P12 P13 P14
'
GOSUB :Band
GOTO :Start
' -------------------------------------------------------
' Compute 1 : 1 Quad H + 1 Triangle
:Suite1
'PRINT "0 Suite1 X11 =" X11 "X12 =" X12 "X13 =" X13 "X14 =" X14
'
IF X11>X94 THEN GOTO :StartPre
IF X12=X94 THEN GOTO :Suite2
IF X12>X94 THEN GOTO :Suite3
IF X14=X94 THEN GOTO :Suite4
IF X14>X94 THEN GOTO :Suite4
'
4 F P11 P12 P23 P14
3 F P12 P93 P23
'
GOSUB :Band
GOTO :Suite1
'
' Compute 2 : 1 Quad H
:Suite2
'PRINT "0 Suite2 X11 =" X11 "X12 =" X12 "X13 =" X13 "X14 =" X14
'
IF X11>X94 THEN GOTO :StartPre
IF X12>X94 THEN GOTO :Suite3
IF X14=X94 THEN GOTO :Suite4
IF X14>X94 THEN GOTO :Suite4
'
4 F P11 P93 P23 P14
'
GOSUB :Band
GOTO :Suite2
'
' Compute 3 : 1 Quad Mini
:Suite3
'PRINT "0 Suite3 X11 =" X11 "X12 =" X12 "X13 =" X13 "X14 =" X14
'
IF X11>X94 THEN GOTO :StartPre
IF X14=X94 THEN GOTO :Suite4
IF X14>X94 THEN GOTO :Suite4
'
4 F P11 P24 P23 P14
'
GOSUB :Band
GOTO :Suite3
'
' Compute 4 : 1 Triangle Corner
:Suite4
'PRINT "0 Suite4 X11 =" X11 "X12 =" X12 "X13 =" X13 "X14 =" X14
'
IF X11>=X94 THEN GOTO :StartPre
'
3 F P11 P24 P94
'
GOSUB :Band
GOTO :Suite4
'
' -------------------------------------------------------
' Compute : Firsts Pre Band
:StartPre
LET F = E
GOSUB :Pre
'
:Pre1
'PRINT "0 Pre1 X31 =" X31 "X32 =" X32 "X33 =" X33 "X34 =" X34
IF X33=X92 THEN GOTO :Box
IF X33<X92 THEN GOTO :Box
IF X34=X91 THEN GOTO :Pre2
IF X34<X91 THEN GOTO :Pre3
IF X32=X92 THEN GOTO :Pre4
IF X32<X92 THEN GOTO :Pre4
'
4 F P44 P32 P33 P34
3 F P91 P44 P34
'
GOSUB :Pre
GOTO :Pre1
'
:Pre2
'PRINT "0 Pre2 X31 =" X31 "X32 =" X32 "X33 =" X33 "X34 =" X34
IF X33=X92 THEN GOTO :Box
IF X33<X92 THEN GOTO :Box
IF X34<X91 THEN GOTO :Pre3
IF X32=X92 THEN GOTO :Pre4
IF X32<X92 THEN GOTO :Pre4
'
4 F P44 P32 P33 P92
'
GOSUB :Pre
GOTO :Pre2
'
:Pre3
'PRINT "0 Pre3 X31 =" X31 "X32 =" X32 "X33 =" X33 "X34 =" X34
IF X33=X92 THEN GOTO :Box
IF X33<X92 THEN GOTO :Box
IF X32=X92 THEN GOTO :Pre4
IF X32<X92 THEN GOTO :Pre4
'
4 F P43 P44 P32 P33
'
GOSUB :Pre
GOTO :Pre3
'
:Pre4
'PRINT "0 Pre4 X31 =" X31 "X32 =" X32 "X33 =" X33 "X34 =" X34
IF X33=X92 THEN GOTO :Box
IF X33<X92 THEN GOTO :Box
'
3 F P43 P92 P33
'
GOSUB :Pre
GOTO :Pre4
' -------------------------------------------------------
' Box of Sticker
:Box
PRINT "0 // Box"
'
IF F=0 THEN
  4 C W*-1 0 H  W*-1 0 H*-1  W 0 H*-1  W 0 H
  '
  4 C W 0 H  W 0 H*-1  W T*-1 H*-1  W T*-1 H
  4 C W*-1 T*-1 H  W*-1 T*-1 H*-1  W*-1 0 H*-1  W*-1 0 H
  4 C W T*-1 H  W*-1 T*-1 H  W*-1 0 H  W 0 H
  4 C W 0 H*-1  W*-1 0 H*-1  W*-1 T*-1 H*-1  W T*-1 H*-1
ELSE
  1 C 0 T*-1 0 W 0 0 0 T 0 0 0 H box5-12.dat
ENDIF
' -------------------------------------------------------
' End of Script
:End
PRINT "0 // End Script stk_band.lds"
END
'
' -------------------------------------------------------
' Program Compute Band Values
:Band
LET X11=X14
LET X12=X13
'
IF F=D THEN
     LET F=E
     LET X13=X13+X2
     LET X14=X14+X2
     LET X20=X2
ELSE
     LET F=D
     LET X13=X13+X1
     LET X14=X14+X1
     LET X20=X1
ENDIF
'
P22 W T*-1 H
LET Q=(X94-X14)*2*H
LET Q=Q/X3
P23 W T*-1 Q-H
'PRINT "0 X23 =" X23 "Y23 =" Y23 "Z23 =" Z23
LET Q=(X94-X11)*2*H
LET Q=Q/X3
P24 W T*-1 Q-H
'PRINT "0 X24 =" X24 "Y24 =" Y24 "Z24 =" Z24
'
RETURN
'
' -------------------------------------------------------
' Program Compute Pre Band Values
:Pre
LET X34=X31
LET X33=X32
'
IF F=D THEN
     LET F=E
     LET X31=X31-X2
     LET X32=X32-X2
     LET X20=X2
ELSE
     LET F=D
     LET X31=X31-X1
     LET X32=X32-X1
     LET X20=X1
ENDIF
'
P31 X31 T*-1 H*-1
P32 X32 T*-1 H
LET Q=(X91-X34)*2*H
LET Q=Q/X3
P43 W*-1 T*-1 Q-H
LET Q=(X91-X31)*2*H
LET Q=Q/X3
P44 W*-1 T*-1 Q-H
' PRINT "0 Pre X31 =" X31 "X32 =" X32 "X33 =" X33 "X34 =" X34
'
RETURN
' -------------------------------------------------------

