' -------------------------------------------------------
' Sticker with Round Corners
' Author : J.C. Tchang
' Script for LDS
' Modif A 13-04-2023 : New script
' -------------------------------------------------------
' Parameters
' Height of Sticker in LDU (modify value)
LET H=10
' Width of Sticker in LDU (modify value)
LET W=16
' Corner radius
LET R=2
' Thickness of Sticker in LDU (default value)
LET T=0.25
' Color of Sticker (default value)
LET C=16
' -------------------------------------------------------
' Main Program
PRINT "0 Sticker with Round Corners";
PRINT W;
PRINT "x";
PRINT H;
PRINT "R=";
PRINT R
PRINT "0 Name: stk_round_corner.dat"
PRINT "0 Author: LDS by J.C. Tchang's Script stk_round_corner.lds"
PRINT "0 BFC CERTIFY CCW"
PRINT "0 //"
PRINT "0 // Base"
'
' Init values
LET H=H/2
LET I=H-R
LET W=W/2
LET X=W-R
' -------------------------------------------------------
' Box of Sticker
:Box
'
PRINT "0 // Box : Base"
1 C X T I*-1 R 0 0 0 -1 0 0 0 R*-1 1-4chrd.dat
1 C X T I R 0 0 0 -1 0 0 0 R 1-4chrd.dat
1 C X*-1 T I*-1 R*-1 0 0 0 -1 0 0 0 R*-1 1-4chrd.dat
1 C X*-1 T I R*-1 0 0 0 -1 0 0 0 R 1-4chrd.dat
4 C W T I W T I*-1 X T H*-1 X T H
4 C W*-1 T I X*-1 T H X*-1 T H*-1 W*-1 T I*-1  
4 C X T H X T H*-1 X*-1 T H*-1 X*-1 T H
'
PRINT "0 // Box : Edges"
1 C X T I*-1 R 0 0 0 T*-1 0 0 0 R*-1 1-4cyli.dat
1 C X T I R 0 0 0 T*-1 0 0 0 R 1-4cyli.dat
1 C X*-1 T I*-1 R*-1 0 0 0 T*-1 0 0 0 R*-1 1-4cyli.dat
1 C X*-1 T I R*-1 0 0 0 T*-1 0 0 0 R 1-4cyli.dat
4 C W T I*-1 W T I W 0 I W 0 I*-1
4 C W*-1 T I*-1 W*-1 0 I*-1 W*-1 0 I W*-1 T I
4 C X T H X*-1 T H X*-1 0 H X 0 H
4 C X T H*-1 X 0 H*-1 X*-1 0 H*-1 X*-1 T H*-1
'
PRINT "0 // Box : End"
' -------------------------------------------------------
' Template for LPC
:template
'
PRINT "Code for Template of LPC"
PRINT "1"
PRINT "0 // Insert Here Box Code in One Line with <br> Separators"
PRINT "1 0 0 0"
PRINT "0 1 0 0"
PRINT "0 0 1 0"
PRINT "0 0 0 1"
PRINT X H*-1
PRINT W I*-1
1 C X 0 I*-1 R 0 0 0 1 0 0 0 R 1-4chrd.dat
PRINT W I*-1
PRINT W I
PRINT X H
1 C X 0 I R 0 0 0 1 0 0 0 R*-1 1-4chrd.dat
PRINT X H
PRINT X*-1 H
PRINT W*-1 I
1 C X*-1 0 I R*-1 0 0 0 1 0 0 0 R*-1 1-4chrd.dat
PRINT W*-1 I
PRINT W*-1 I*-1
PRINT X*-1 H*-1
1 C X*-1 0 I*-1 R*-1 0 0 0 1 0 0 0 R 1-4chrd.dat
PRINT X*-1 H*-1
' -------------------------------------------------------
' End of Script
'
:End
PRINT "0 // End stk_round_corner.lds"
END
' =======================================================



